## ruli 0.18-1

=== src/Makefile ===
#
# $Id: Makefile,v 1.31 2004/02/25 17:54:39 evertonm Exp $
#

#DEBUG = -DRULI_RES_DEBUG -DRULI_SRV_DEBUG -DRULI_TXT_COMPARE_DEBUG
#DEBUG = -DRULI_SYNC_DEBUG
#DEBUG = -DRULI_SEARCH_DEBUG
#DEBUG = -DRULI_MSG_DUMP_DEBUG -DRULI_SOCK_DUMP_DEBUG
#DEBUG = -DRULI_SMTP_DEBUG

#
# OOP_INCLUDE_DIR points the location of
# Liboop headers in your system
#
# Debian packaging likes this: OOP_BASE_DIR = /usr/lib
#
OOP_BASE_DIR    = /usr/lib
OOP_INCLUDE_DIR = $(OOP_BASE_DIR)/include

#
# INSTALL_BASE_DIR indicates where RULI
# is to be installed in your system
#
# Example: INSTALL_BASE_DIR=/usr/local/ruli
#
# Debian packaging likes this: INSTALL_BASE_DIR = $(DESTDIR)/usr
#
INSTALL_BASE_DIR     = $(DESTDIR)/usr
INSTALL_INCLUDE_DIR  = $(INSTALL_BASE_DIR)/include
INSTALL_LIB_DIR      = $(INSTALL_BASE_DIR)/lib
INSTALL_MAN_DIR      = $(INSTALL_BASE_DIR)/share/man

WARN = -pedantic -Wshadow -Wpointer-arith -Wcast-qual \
	-Wcast-align -Wwrite-strings -Wstrict-prototypes \
	-Wmissing-prototypes -Wnested-externs -Wredundant-decls \
        -Werror

CC     = gcc
CFLAGS = $(DEBUG) $(WARN) -O2 -pipe -Wall -g -shared -fPIC \
	-I. -I$(OOP_INCLUDE_DIR)
LIBOBJ = ruli_isaac.o ruli_mem.o ruli_rand.o ruli_util.o ruli_list.o ruli_sock.o \
	ruli_txt.o ruli_msg.o ruli_fsm.o ruli_res.o ruli_parse.o \
	ruli_srv.o ruli_conf.o ruli_search.o ruli_smtp.o ruli_sync.o
SONAME = libruli.so.1

.PHONY: default
default: ruli

.PHONY: clean
clean:
	rm -f *~ .*~ *.o *.so *.a *.so.*

.PHONY: build
build: clean default

.PHONY: strip
strip: ruli
	strip $(SONAME) libruli.a

.PHONY: install
install: ruli
	install -d $(INSTALL_LIB_DIR) $(INSTALL_INCLUDE_DIR) $(INSTALL_MAN_DIR)/man3
	install -m 644 $(SONAME) libruli.a $(INSTALL_LIB_DIR)
	install -m 644 *.h $(INSTALL_INCLUDE_DIR)
	install -m 644 ../doc/man/*.3 $(INSTALL_MAN_DIR)/man3
	cd $(INSTALL_LIB_DIR) && ln -s $(SONAME) libruli.so
	@echo
	@echo "REMINDER:"
	@echo "Add $(INSTALL_LIB_DIR) to your dynamic loader path:"
	@echo "# echo $(INSTALL_LIB_DIR) >> /etc/ld.so.conf"
	@echo "# ldconfig"
	@echo

.PHONY: ruli
ruli: $(SONAME) libruli.a

ruli_isaac.o: ruli_isaac.c ruli_isaac.h
	$(CC) $(CFLAGS) -c $<

ruli_mem.o: ruli_mem.c ruli_mem.h
	$(CC) $(CFLAGS) -c $<

ruli_rand.o: ruli_rand.c ruli_rand.h
	$(CC) $(CFLAGS) -c $<

ruli_util.o: ruli_util.c ruli_util.h
	$(CC) $(CFLAGS) -c $<

ruli_list.o: ruli_list.c ruli_list.h
	$(CC) $(CFLAGS) -c $<

ruli_sock.o: ruli_sock.c ruli_sock.h
	$(CC) $(CFLAGS) -c $<

ruli_txt.o: ruli_txt.c ruli_txt.h ruli_limits.h
	$(CC) $(CFLAGS) -c $<

ruli_msg.o: ruli_msg.c ruli_msg.h ruli_limits.h
	$(CC) $(CFLAGS) -c $<

ruli_fsm.o: ruli_fsm.c ruli_fsm.h
	$(CC) $(CFLAGS) -c $<

ruli_res.o: ruli_res.c ruli_res.h
	$(CC) $(CFLAGS) -c $<

ruli_parse.o: ruli_parse.c ruli_parse.h
	$(CC) $(CFLAGS) -c $<

ruli_srv.o: ruli_srv.c ruli_srv.h
	$(CC) $(CFLAGS) -c $<

ruli_conf.o: ruli_conf.c ruli_conf.h
	$(CC) $(CFLAGS) -c $<

ruli_search.o: ruli_search.c ruli_search.h
	$(CC) $(CFLAGS) -c $<

ruli_smtp.o: ruli_smtp.c ruli_smtp.h
	$(CC) $(CFLAGS) -c $<

ruli_sync.o: ruli_sync.c ruli_sync.h
	$(CC) $(CFLAGS) -c $<

libruli.so: $(LIBOBJ)
	$(CC) $(CFLAGS) -Wl,-soname,$(SONAME) -o $@ $(LIBOBJ)

$(SONAME): libruli.so
	cp libruli.so $(SONAME)

#
# Solaris ar
#
#libruli.a: $(LIBOBJ)
#	ar -r -v $@ $(LIBOBJ)

#
# GNU ar
#
libruli.a: $(LIBOBJ)
	ar rcv $@ $(LIBOBJ)
	ar sv $@

=== debian/changelog ===
ruli (0.18-1) unstable; urgency=low

  * New upstream release.
  * Removed unused '${misc:Depends}' from 'debian/control'.

 -- Everton da Silva Marques <evertonsm@yahoo.com.br>  Wed, 17 Mar 2004 21:03:12 -0300

ruli (0.17-2) unstable; urgency=low

  * Removed inocuous comments from 'debian/rules'.
  * Added detection of shared library version to 'debian/rules'.
  * Removed unused files.
  * Added bogus man page.
  * Closes: #234303

 -- Everton da Silva Marques <evertonsm@yahoo.com.br>  Wed, 25 Feb 2004 00:05:56 -0300

ruli (0.17-1) unstable; urgency=low

  * Initial Release.
  * Adjusted the Makefile to fix $DESTDIR problems.
  * Added top level Makefile.
  * Changed src/Makefile to use 'install -m 644' instead of 'cp'.
  * Changed src/Makefile to issue 'libruli.so.1' instead of 'libruli.so'.
  * Added SONAME to 'libruli.so.1' in src/Makefile.

 -- Everton da Silva Marques <evertonsm@yahoo.com.br>  Sun, 22 Feb 2004 00:12:25 -0300

=== debian/control ===
Source: ruli
Priority: optional
Maintainer: Everton da Silva Marques <evertonsm@yahoo.com.br>
Build-Depends: debhelper (>= 4.0.0), binutils (>= 2.14.90.0.7-5), gcc-3.3 (>= 1), libacl1 (>= 2.2.23-1), libattr1 (>= 2.4.15-1), libc6 (>= 2.3.2.ds1-11), libc6-dev (>= 2.3.2.ds1-11), liboop-dev (>= 1.0-1), linux-kernel-headers (>= 2.5.999-test7-bk-15)
Standards-Version: 3.6.0

Package: libruli1-dev
Section: devel
Architecture: any
Depends: libruli1 (= ${Source-Version}), liboop-dev (>= 1.0-1)
Provides: libruli-dev
Conflicts: libruli-dev
Description: Library for easily querying DNS SRV records - development files
 RULI stands for Resolver User Layer Interface. It's a library
 built on top of an asychronous DNS stub resolver. RULI
 provides an easy-to-use interface for querying DNS SRV
 resource records. The goal is to promote the wide deployment
 of SRV-cognizant client programs. RULI aims to fully support
 SRV-related standards.
 .
 This package contains the RULI development libraries and
 header files, required to develop and/or compile
 applications that use RULI.

Package: libruli1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, liboop4 (>= 1.0-1)
Provides: libruli
Description: Library for easily querying DNS SRV records
 RULI stands for Resolver User Layer Interface. It's a library
 built on top of an asychronous DNS stub resolver. RULI
 provides an easy-to-use interface for querying DNS SRV
 resource records. The goal is to promote the wide deployment
 of SRV-cognizant client programs. RULI aims to fully support
 SRV-related standards.

## ruli 0.20

=== Makefile ===
#
# $Id: Makefile,v 1.4 2004/03/26 19:58:42 evertonm Exp $
#
# This is a Debian-friendly top-level Makefile.
#

.PHONY: default
default:
	$(MAKE) -C src   
	$(MAKE) -C sample 

.PHONY: clean
clean:
	$(MAKE) -C src    clean
	$(MAKE) -C sample clean

.PHONY: install
install:
	$(MAKE) -C src    install
	$(MAKE) -C sample install

.PHONY: dpkg
dpkg:
	dpkg-buildpackage -rfakeroot

=== src/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# $Id: Makefile,v 1.31 2004/02/25 17:54:39 evertonm Exp $
+# $Id: Makefile,v 1.32 2004/03/26 18:57:32 evertonm Exp $
 #
 
 #DEBUG = -DRULI_RES_DEBUG -DRULI_SRV_DEBUG -DRULI_TXT_COMPARE_DEBUG
@@ -14,7 +14,7 @@
 #
 # Debian packaging likes this: OOP_BASE_DIR = /usr/lib
 #
-OOP_BASE_DIR    = /usr/lib
+OOP_BASE_DIR    = /usr/local/oop
 OOP_INCLUDE_DIR = $(OOP_BASE_DIR)/include
 
 #
@@ -25,7 +25,7 @@
 #
 # Debian packaging likes this: INSTALL_BASE_DIR = $(DESTDIR)/usr
 #
-INSTALL_BASE_DIR     = $(DESTDIR)/usr
+INSTALL_BASE_DIR     = ../install/ruli
 INSTALL_INCLUDE_DIR  = $(INSTALL_BASE_DIR)/include
 INSTALL_LIB_DIR      = $(INSTALL_BASE_DIR)/lib
 INSTALL_MAN_DIR      = $(INSTALL_BASE_DIR)/share/man
@@ -59,7 +59,9 @@
 
 .PHONY: install
 install: ruli
-	install -d $(INSTALL_LIB_DIR) $(INSTALL_INCLUDE_DIR) $(INSTALL_MAN_DIR)/man3
+	install -d $(INSTALL_LIB_DIR) \
+		$(INSTALL_INCLUDE_DIR) \
+		$(INSTALL_MAN_DIR)/man3
 	install -m 644 $(SONAME) libruli.a $(INSTALL_LIB_DIR)
 	install -m 644 *.h $(INSTALL_INCLUDE_DIR)
 	install -m 644 ../doc/man/*.3 $(INSTALL_MAN_DIR)/man3

## ruli 0.21

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# $Id: Makefile,v 1.4 2004/03/26 19:58:42 evertonm Exp $
+# $Id: Makefile,v 1.7 2004/05/21 19:34:16 evertonm Exp $
 #
 # This is a Debian-friendly top-level Makefile.
 #
@@ -22,3 +22,12 @@
 .PHONY: dpkg
 dpkg:
 	dpkg-buildpackage -rfakeroot
+
+.PHONY: dpkg-clean
+dpkg-clean:
+	fakeroot debian/rules clean
+
+.PHONY: release-clean
+release-clean:
+	rm -r debian doc/rfc ruli-mta test tube `find . -name CVS`
+

=== sample/Makefile ===
#
# $Id: Makefile,v 1.7 2004/05/17 05:51:13 evertonm Exp $
#

#
# OOP_INCLUDE_DIR points the location of
# Liboop headers in your system
#
# OOP_LIB_DIR points the location of
# Liboop libraries in your system
#
# Debian packaging likes this: OOP_BASE_DIR = /usr/lib
#

OOP_BASE_DIR    = /usr/local/oop
OOP_INCLUDE_DIR = $(OOP_BASE_DIR)/include
OOP_LIB_DIR     = $(OOP_BASE_DIR)/lib

#
# INSTALL_BASE_DIR indicates where RULI
# is to be installed in your system
#
# Debian packaging likes this: INSTALL_BASE_DIR = $(DESTDIR)/usr
#
INSTALL_BASE_DIR    = ../install/ruli
INSTALL_INCLUDE_DIR = $(INSTALL_BASE_DIR)/include
INSTALL_LIB_DIR     = $(INSTALL_BASE_DIR)/lib
INSTALL_BIN_DIR     = $(INSTALL_BASE_DIR)/bin
INSTALL_MAN_DIR     = $(INSTALL_BASE_DIR)/share/man

#SOLARIS_LDFLAGS = -lresolv -lnsl -R$(OOP_LIB_DIR) -R$(INSTALL_LIB_DIR)

CC      = gcc
CFLAGS  = -O2 -pipe -Wall -g -I$(INSTALL_INCLUDE_DIR) -I$(OOP_INCLUDE_DIR) \
	-I../src
LDFLAGS = -L$(INSTALL_LIB_DIR) -L$(OOP_LIB_DIR) -lruli -loop \
	$(SOLARIS_LDFLAGS) -L../src

TARGETS = srvsearch sync_srvsearch smtpsearch sync_smtpsearch

.PHONY: default
default: $(TARGETS)

.PHONY: clean
clean:
	rm -f *~ .*~ *.o $(TARGETS)

.PHONY: build
build: clean default

.PHONY: strip
strip: $(TARGETS)
	strip $(TARGETS)

.PHONY: install
install: $(TARGETS)
	install -d $(INSTALL_BIN_DIR) $(INSTALL_MAN_DIR)/man1
	install -m 755 $(TARGETS) $(INSTALL_BIN_DIR)
	install -m 644 ../doc/man/*.1 $(INSTALL_MAN_DIR)/man1
	cd $(INSTALL_MAN_DIR)/man1 && ln -s srvsearch.1 smtpsearch.1
	cd $(INSTALL_MAN_DIR)/man1 && ln -s srvsearch.1 sync_srvsearch.1
	cd $(INSTALL_MAN_DIR)/man1 && ln -s srvsearch.1 sync_smtpsearch.1

srvsearch: srvsearch.o stdout_srv_list.o
	$(CC) $(LDFLAGS) -o $@ $^

sync_srvsearch: sync_srvsearch.o stdout_srv_list.o
	$(CC) $(LDFLAGS) -o $@ $^

smtpsearch: smtpsearch.o stdout_srv_list.o
	$(CC) $(LDFLAGS) -o $@ $^

sync_smtpsearch: sync_smtpsearch.o stdout_srv_list.o
	$(CC) $(LDFLAGS) -o $@ $^

=== src/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# $Id: Makefile,v 1.32 2004/03/26 18:57:32 evertonm Exp $
+# $Id: Makefile,v 1.33 2004/05/17 05:51:13 evertonm Exp $
 #
 
 #DEBUG = -DRULI_RES_DEBUG -DRULI_SRV_DEBUG -DRULI_TXT_COMPARE_DEBUG
@@ -125,7 +125,7 @@
 	$(CC) $(CFLAGS) -c $<
 
 libruli.so: $(LIBOBJ)
-	$(CC) $(CFLAGS) -Wl,-soname,$(SONAME) -o $@ $(LIBOBJ)
+	$(CC) $(CFLAGS) -Wl,-soname,$(SONAME) -o $@ $(LIBOBJ) -loop
 
 $(SONAME): libruli.so
 	cp libruli.so $(SONAME)

=== tools/Makefile ===
#
# $Id: Makefile,v 1.16 2004/05/19 23:09:11 evertonm Exp $
#

#
# OOP_INCLUDE_DIR points the location of
# Liboop headers in your system
#
# OOP_LIB_DIR points the location of
# Liboop libraries in your system
#
OOP_BASE_DIR    = /usr/local/oop
OOP_INCLUDE_DIR = $(OOP_BASE_DIR)/include
OOP_LIB_DIR     = $(OOP_BASE_DIR)/lib

#
# INSTALL_BASE_DIR indicates where RULI
# is to be installed in your system
#
INSTALL_BASE_DIR    = ../install/ruli
INSTALL_INCLUDE_DIR = $(INSTALL_BASE_DIR)/include
INSTALL_LIB_DIR     = $(INSTALL_BASE_DIR)/lib
INSTALL_BIN_DIR     = $(INSTALL_BASE_DIR)/bin

#SOLARIS_LDFLAGS = -lresolv -lnsl -R$(OOP_LIB_DIR) -R$(INSTALL_LIB_DIR)

CC      = gcc
CFLAGS  = -O2 -pipe -Wall -g -I$(INSTALL_INCLUDE_DIR) -I$(OOP_INCLUDE_DIR) \
          -I../src

LDFLAGS = -L$(INSTALL_LIB_DIR) -L$(OOP_LIB_DIR) -lruli -loop $(SOLARIS_LDFLAGS) \
          -L../src

TARGETS = list resolve hostsolver srvsolver syncsolver addrsolver \
	srvsolver2 addrsolver2 addrsolver3 rand cycle_res cycle_res2

.PHONY: default
default: $(TARGETS)

.PHONY: clean
clean:
	rm -f *~ .*~ *.o $(TARGETS)

.PHONY: build
build: clean default

.PHONY: strip
strip: $(TARGETS)
	strip $(TARGETS)

.PHONY: install
install: $(TARGETS)
	[ -d $(INSTALL_BIN_DIR) ] || mkdir -p $(INSTALL_BIN_DIR) || exit
	cp $(TARGETS) $(INSTALL_BIN_DIR)

resolve: resolve.o trivial_conf_handler.o
	$(CC) $(LDFLAGS) -o $@ $^

hostsolver: hostsolver.o stdin_domains.o trivial_conf_handler.o
	$(CC) $(LDFLAGS) -o $@ $^

srvsolver: srvsolver.o stdin_domains.o stdout_srv_list.o trivial_conf_handler.o
	$(CC) $(LDFLAGS) -o $@ $^

srvsolver2: srvsolver2.o stdout_srv_list.o trivial_conf_handler.o
	$(CC) $(LDFLAGS) -o $@ $^

syncsolver: syncsolver.o stdout_srv_list.o
	$(CC) $(LDFLAGS) -o $@ $^

addrsolver: addrsolver.o trivial_conf_handler.o
	$(CC) $(LDFLAGS) -o $@ $^

addrsolver2: addrsolver2.o trivial_conf_handler.o
	$(CC) $(LDFLAGS) -o $@ $^

addrsolver3: addrsolver3.o trivial_conf_handler.o
	$(CC) $(LDFLAGS) -o $@ $^

cycle_res: cycle_res.o trivial_conf_handler.o
	$(CC) $(LDFLAGS) -o $@ $^

cycle_res2: cycle_res2.o trivial_conf_handler.o
	$(CC) $(LDFLAGS) -o $@ $^

## ruli 0.22

=== sample/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# $Id: Makefile,v 1.7 2004/05/17 05:51:13 evertonm Exp $
+# $Id: Makefile,v 1.8 2004/05/28 22:17:03 evertonm Exp $
 #
 
 #
@@ -36,7 +36,7 @@
 LDFLAGS = -L$(INSTALL_LIB_DIR) -L$(OOP_LIB_DIR) -lruli -loop \
 	$(SOLARIS_LDFLAGS) -L../src
 
-TARGETS = srvsearch sync_srvsearch smtpsearch sync_smtpsearch
+TARGETS = srvsearch sync_srvsearch smtpsearch sync_smtpsearch ruli-getaddrinfo
 
 .PHONY: default
 default: $(TARGETS)
@@ -73,5 +73,6 @@
 sync_smtpsearch: sync_smtpsearch.o stdout_srv_list.o
 	$(CC) $(LDFLAGS) -o $@ $^
 
+ruli-getaddrinfo: ruli-getaddrinfo.o stdout_srv_list.o
+	$(CC) $(LDFLAGS) -o $@ $^
 
-

=== src/Makefile ===
--- 
+++ 
@@ -1,12 +1,12 @@
 #
-# $Id: Makefile,v 1.33 2004/05/17 05:51:13 evertonm Exp $
+# $Id: Makefile,v 1.37 2004/05/31 05:57:40 evertonm Exp $
 #
 
 #DEBUG = -DRULI_RES_DEBUG -DRULI_SRV_DEBUG -DRULI_TXT_COMPARE_DEBUG
-#DEBUG = -DRULI_SYNC_DEBUG
-#DEBUG = -DRULI_SEARCH_DEBUG
-#DEBUG = -DRULI_MSG_DUMP_DEBUG -DRULI_SOCK_DUMP_DEBUG
-#DEBUG = -DRULI_SMTP_DEBUG
+#DEBUG += -DRULI_SYNC_DEBUG
+#DEBUG += -DRULI_SEARCH_DEBUG
+#DEBUG += -DRULI_MSG_DUMP_DEBUG -DRULI_SOCK_DUMP_DEBUG
+#DEBUG += -DRULI_SMTP_DEBUG
 
 #
 # OOP_INCLUDE_DIR points the location of
@@ -30,7 +30,7 @@
 INSTALL_LIB_DIR      = $(INSTALL_BASE_DIR)/lib
 INSTALL_MAN_DIR      = $(INSTALL_BASE_DIR)/share/man
 
-WARN = -pedantic -Wshadow -Wpointer-arith -Wcast-qual \
+WARN = -pedantic -ansi -Wshadow -Wpointer-arith -Wcast-qual \
 	-Wcast-align -Wwrite-strings -Wstrict-prototypes \
 	-Wmissing-prototypes -Wnested-externs -Wredundant-decls \
         -Werror
@@ -38,10 +38,11 @@
 CC     = gcc
 CFLAGS = $(DEBUG) $(WARN) -O2 -pipe -Wall -g -shared -fPIC \
 	-I. -I$(OOP_INCLUDE_DIR)
-LIBOBJ = ruli_isaac.o ruli_mem.o ruli_rand.o ruli_util.o ruli_list.o ruli_sock.o \
-	ruli_txt.o ruli_msg.o ruli_fsm.o ruli_res.o ruli_parse.o \
-	ruli_srv.o ruli_conf.o ruli_search.o ruli_smtp.o ruli_sync.o
-SONAME = libruli.so.1
+LIBOBJ = ruli_isaac.o ruli_mem.o ruli_rand.o ruli_util.o ruli_list.o \
+	ruli_addr.o ruli_sock.o ruli_txt.o ruli_msg.o ruli_fsm.o \
+	ruli_res.o ruli_parse.o ruli_srv.o ruli_conf.o ruli_search.o \
+	ruli_smtp.o ruli_sync.o ruli_getaddrinfo.o
+SONAME = libruli.so.2
 
 .PHONY: default
 default: ruli
@@ -91,6 +92,9 @@
 ruli_list.o: ruli_list.c ruli_list.h
 	$(CC) $(CFLAGS) -c $<
 
+ruli_addr.o: ruli_addr.c ruli_addr.h
+	$(CC) $(CFLAGS) -c $<
+
 ruli_sock.o: ruli_sock.c ruli_sock.h
 	$(CC) $(CFLAGS) -c $<
 
@@ -124,8 +128,11 @@
 ruli_sync.o: ruli_sync.c ruli_sync.h
 	$(CC) $(CFLAGS) -c $<
 
+ruli_getaddrinfo.o: ruli_getaddrinfo.c ruli_getaddrinfo.h
+	$(CC) $(CFLAGS) -c $<
+
 libruli.so: $(LIBOBJ)
-	$(CC) $(CFLAGS) -Wl,-soname,$(SONAME) -o $@ $(LIBOBJ) -loop
+	$(CC) $(CFLAGS) -Wl,-soname,$(SONAME) -o $@ $(LIBOBJ) -loop -ldl
 
 $(SONAME): libruli.so
 	cp libruli.so $(SONAME)

## ruli 0.23

=== sample/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# $Id: Makefile,v 1.8 2004/05/28 22:17:03 evertonm Exp $
+# $Id: Makefile,v 1.9 2004/05/31 22:18:03 evertonm Exp $
 #
 
 #
@@ -60,6 +60,7 @@
 	cd $(INSTALL_MAN_DIR)/man1 && ln -s srvsearch.1 smtpsearch.1
 	cd $(INSTALL_MAN_DIR)/man1 && ln -s srvsearch.1 sync_srvsearch.1
 	cd $(INSTALL_MAN_DIR)/man1 && ln -s srvsearch.1 sync_smtpsearch.1
+	cd $(INSTALL_MAN_DIR)/man1 && ln -s srvsearch.1 ruli-getaddrinfo.1
 
 srvsearch: srvsearch.o stdout_srv_list.o
 	$(CC) $(LDFLAGS) -o $@ $^

=== perl/RULI/Makefile ===
# This Makefile is for the RULI extension to perl.
#
# It was generated automatically by MakeMaker version
# 6.17 (Revision: 1.133) from the contents of
# Makefile.PL. Don't edit this file, edit Makefile.PL instead.
#
#       ANY CHANGES MADE HERE WILL BE LOST!
#
#   MakeMaker ARGV: ()
#
#   MakeMaker Parameters:

#     ABSTRACT_FROM => q[lib/RULI.pm]
#     AUTHOR => q[Everton da Silva Marques <evertonsm@yahoo.com.br>]
#     DEFINE => q[]
#     INC => q[-I. -I/usr/local/ruli/include]
#     LIBS => [q[-L/usr/local/ruli/lib -lruli -loop]]
#     NAME => q[RULI]
#     PREREQ_PM => {  }
#     VERSION_FROM => q[lib/RULI.pm]

# --- MakeMaker post_initialize section:


# --- MakeMaker const_config section:

# These definitions are from config.sh (via /usr/lib/perl/5.8/Config.pm)

# They may have been overridden via Makefile.PL or on the command line
AR = ar
CC = cc
CCCDLFLAGS = -fPIC
CCDLFLAGS = -rdynamic
DLEXT = so
DLSRC = dl_dlopen.xs
LD = cc
LDDLFLAGS = -shared -L/usr/local/lib
LDFLAGS =  -L/usr/local/lib
LIBC = /lib/libc-2.3.2.so
LIB_EXT = .a
OBJ_EXT = .o
OSNAME = linux
OSVERS = 2.4.25-ti1211
RANLIB = :
SITELIBEXP = /usr/local/share/perl/5.8.3
SITEARCHEXP = /usr/local/lib/perl/5.8.3
SO = so
EXE_EXT = 
FULL_AR = /usr/bin/ar
VENDORARCHEXP = /usr/lib/perl5
VENDORLIBEXP = /usr/share/perl5


# --- MakeMaker constants section:
AR_STATIC_ARGS = cr
DIRFILESEP = /
NAME = RULI
NAME_SYM = RULI
VERSION = 0.01
VERSION_MACRO = VERSION
VERSION_SYM = 0_01
DEFINE_VERSION = -D$(VERSION_MACRO)=\"$(VERSION)\"
XS_VERSION = 0.01
XS_VERSION_MACRO = XS_VERSION
XS_DEFINE_VERSION = -D$(XS_VERSION_MACRO)=\"$(XS_VERSION)\"
INST_ARCHLIB = blib/arch
INST_SCRIPT = blib/script
INST_BIN = blib/bin
INST_LIB = blib/lib
INST_MAN1DIR = blib/man1
INST_MAN3DIR = blib/man3
MAN1EXT = 1p
MAN3EXT = 3pm
INSTALLDIRS = site
DESTDIR = 
PREFIX = /usr
PERLPREFIX = $(PREFIX)
SITEPREFIX = $(PREFIX)/local
VENDORPREFIX = $(PREFIX)
INSTALLPRIVLIB = $(PERLPREFIX)/share/perl/5.8
DESTINSTALLPRIVLIB = $(DESTDIR)$(INSTALLPRIVLIB)
INSTALLSITELIB = $(SITEPREFIX)/share/perl/5.8.3
DESTINSTALLSITELIB = $(DESTDIR)$(INSTALLSITELIB)
INSTALLVENDORLIB = $(VENDORPREFIX)/share/perl5
DESTINSTALLVENDORLIB = $(DESTDIR)$(INSTALLVENDORLIB)
INSTALLARCHLIB = $(PERLPREFIX)/lib/perl/5.8
DESTINSTALLARCHLIB = $(DESTDIR)$(INSTALLARCHLIB)
INSTALLSITEARCH = $(SITEPREFIX)/lib/perl/5.8.3
DESTINSTALLSITEARCH = $(DESTDIR)$(INSTALLSITEARCH)
INSTALLVENDORARCH = $(VENDORPREFIX)/lib/perl5
DESTINSTALLVENDORARCH = $(DESTDIR)$(INSTALLVENDORARCH)
INSTALLBIN = $(PERLPREFIX)/bin
DESTINSTALLBIN = $(DESTDIR)$(INSTALLBIN)
INSTALLSITEBIN = $(SITEPREFIX)/bin
DESTINSTALLSITEBIN = $(DESTDIR)$(INSTALLSITEBIN)
INSTALLVENDORBIN = $(VENDORPREFIX)/bin
DESTINSTALLVENDORBIN = $(DESTDIR)$(INSTALLVENDORBIN)
INSTALLSCRIPT = $(PERLPREFIX)/bin
DESTINSTALLSCRIPT = $(DESTDIR)$(INSTALLSCRIPT)
INSTALLMAN1DIR = $(PERLPREFIX)/share/man/man1
DESTINSTALLMAN1DIR = $(DESTDIR)$(INSTALLMAN1DIR)
INSTALLSITEMAN1DIR = $(SITEPREFIX)/man/man1
DESTINSTALLSITEMAN1DIR = $(DESTDIR)$(INSTALLSITEMAN1DIR)
INSTALLVENDORMAN1DIR = $(VENDORPREFIX)/share/man/man1
DESTINSTALLVENDORMAN1DIR = $(DESTDIR)$(INSTALLVENDORMAN1DIR)
INSTALLMAN3DIR = $(PERLPREFIX)/share/man/man3
DESTINSTALLMAN3DIR = $(DESTDIR)$(INSTALLMAN3DIR)
INSTALLSITEMAN3DIR = $(SITEPREFIX)/man/man3
DESTINSTALLSITEMAN3DIR = $(DESTDIR)$(INSTALLSITEMAN3DIR)
INSTALLVENDORMAN3DIR = $(VENDORPREFIX)/share/man/man3
DESTINSTALLVENDORMAN3DIR = $(DESTDIR)$(INSTALLVENDORMAN3DIR)
PERL_LIB = /usr/share/perl/5.8
PERL_ARCHLIB = /usr/lib/perl/5.8
LIBPERL_A = libperl.a
FIRST_MAKEFILE = Makefile
MAKEFILE_OLD = $(FIRST_MAKEFILE).old
MAKE_APERL_FILE = $(FIRST_MAKEFILE).aperl
PERLMAINCC = $(CC)
PERL_INC = /usr/lib/perl/5.8/CORE
PERL = /usr/bin/perl
FULLPERL = /usr/bin/perl
ABSPERL = $(PERL)
PERLRUN = $(PERL)
FULLPERLRUN = $(FULLPERL)
ABSPERLRUN = $(ABSPERL)
PERLRUNINST = $(PERLRUN) "-I$(INST_ARCHLIB)" "-I$(INST_LIB)"
FULLPERLRUNINST = $(FULLPERLRUN) "-I$(INST_ARCHLIB)" "-I$(INST_LIB)"
ABSPERLRUNINST = $(ABSPERLRUN) "-I$(INST_ARCHLIB)" "-I$(INST_LIB)"
PERL_CORE = 0
PERM_RW = 644
PERM_RWX = 755

MAKEMAKER   = /usr/share/perl/5.8/ExtUtils/MakeMaker.pm
MM_VERSION  = 6.17
MM_REVISION = 1.133

# FULLEXT = Pathname for extension directory (eg Foo/Bar/Oracle).
# BASEEXT = Basename part of FULLEXT. May be just equal FULLEXT. (eg Oracle)
# PARENT_NAME = NAME without BASEEXT and no trailing :: (eg Foo::Bar)
# DLBASE  = Basename part of dynamic library. May be just equal BASEEXT.
FULLEXT = RULI
BASEEXT = RULI
PARENT_NAME = 
DLBASE = $(BASEEXT)
VERSION_FROM = lib/RULI.pm
INC = -I. -I/usr/local/ruli/include
DEFINE = 
OBJECT = $(BASEEXT)$(OBJ_EXT)
LDFROM = $(OBJECT)
LINKTYPE = dynamic

# Handy lists of source code files:
XS_FILES = RULI.xs
C_FILES  = RULI.c
O_FILES  = RULI.o
H_FILES  = ppport.h
MAN1PODS = 
MAN3PODS = lib/RULI.pm

# Where is the Config information that we are using/depend on
CONFIGDEP = $(PERL_ARCHLIB)$(DIRFILESEP)Config.pm $(PERL_INC)$(DIRFILESEP)config.h

# Where to build things
INST_LIBDIR      = $(INST_LIB)
INST_ARCHLIBDIR  = $(INST_ARCHLIB)

INST_AUTODIR     = $(INST_LIB)/auto/$(FULLEXT)
INST_ARCHAUTODIR = $(INST_ARCHLIB)/auto/$(FULLEXT)

INST_STATIC      = $(INST_ARCHAUTODIR)/$(BASEEXT)$(LIB_EXT)
INST_DYNAMIC     = $(INST_ARCHAUTODIR)/$(DLBASE).$(DLEXT)
INST_BOOT        = $(INST_ARCHAUTODIR)/$(BASEEXT).bs

# Extra linker info
EXPORT_LIST        = 
PERL_ARCHIVE       = 
PERL_ARCHIVE_AFTER = 


TO_INST_PM = lib/RULI.pm

PM_TO_BLIB = lib/RULI.pm \
	blib/lib/RULI.pm


# --- MakeMaker platform_constants section:
MM_Unix_VERSION = 1.42
PERL_MALLOC_DEF = -DPERL_EXTMALLOC_DEF -Dmalloc=Perl_malloc -Dfree=Perl_mfree -Drealloc=Perl_realloc -Dcalloc=Perl_calloc


# --- MakeMaker tool_autosplit section:
# Usage: $(AUTOSPLITFILE) FileToSplit AutoDirToSplitInto
AUTOSPLITFILE = $(PERLRUN)  -e 'use AutoSplit;  autosplit($$ARGV[0], $$ARGV[1], 0, 1, 1)'



# --- MakeMaker tool_xsubpp section:

XSUBPPDIR = /usr/share/perl/5.8/ExtUtils
XSUBPP = $(XSUBPPDIR)/xsubpp
XSPROTOARG = 
XSUBPPDEPS = /usr/share/perl/5.8/ExtUtils/typemap $(XSUBPP)
XSUBPPARGS = -typemap /usr/share/perl/5.8/ExtUtils/typemap
XSUBPP_EXTRA_ARGS = 


# --- MakeMaker tools_other section:
SHELL = /bin/sh
CHMOD = chmod
CP = cp
MV = mv
NOOP = $(SHELL) -c true
NOECHO = @
RM_F = rm -f
RM_RF = rm -rf
TEST_F = test -f
TOUCH = touch
UMASK_NULL = umask 0
DEV_NULL = > /dev/null 2>&1
MKPATH = $(PERLRUN) "-MExtUtils::Command" -e mkpath
EQUALIZE_TIMESTAMP = $(PERLRUN) "-MExtUtils::Command" -e eqtime
ECHO = echo
ECHO_N = echo -n
UNINST = 0
VERBINST = 0
MOD_INSTALL = $(PERLRUN) -MExtUtils::Install -e 'install({@ARGV}, '\''$(VERBINST)'\'', 0, '\''$(UNINST)'\'');'
DOC_INSTALL = $(PERLRUN) "-MExtUtils::Command::MM" -e perllocal_install
UNINSTALL = $(PERLRUN) "-MExtUtils::Command::MM" -e uninstall
WARN_IF_OLD_PACKLIST = $(PERLRUN) "-MExtUtils::Command::MM" -e warn_if_old_packlist


# --- MakeMaker makemakerdflt section:
makemakerdflt: all
	$(NOECHO) $(NOOP)


# --- MakeMaker dist section:
TAR = tar
TARFLAGS = cvf
ZIP = zip
ZIPFLAGS = -r
COMPRESS = gzip --best
SUFFIX = .gz
SHAR = shar
PREOP = $(NOECHO) $(NOOP)
POSTOP = $(NOECHO) $(NOOP)
TO_UNIX = $(NOECHO) $(NOOP)
CI = ci -u
RCS_LABEL = rcs -Nv$(VERSION_SYM): -q
DIST_CP = best
DIST_DEFAULT = tardist
DISTNAME = RULI
DISTVNAME = RULI-0.01


# --- MakeMaker macro section:


# --- MakeMaker depend section:


# --- MakeMaker cflags section:

CCFLAGS = -D_REENTRANT -D_GNU_SOURCE -DTHREADS_HAVE_PIDS -DDEBIAN -fno-strict-aliasing -I/usr/local/include -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
OPTIMIZE = -O3
PERLTYPE = 
MPOLLUTE = 


# --- MakeMaker const_loadlibs section:

# RULI might depend on some other libraries:
# See ExtUtils::Liblist for details
#
EXTRALIBS = -L/usr/local/ruli/lib -lruli -loop
LDLOADLIBS = -L/usr/local/ruli/lib -lruli -loop
BSLOADLIBS = 
LD_RUN_PATH = /usr/local/ruli/lib


# --- MakeMaker const_cccmd section:
CCCMD = $(CC) -c $(PASTHRU_INC) $(INC) \
	$(CCFLAGS) $(OPTIMIZE) \
	$(PERLTYPE) $(MPOLLUTE) $(DEFINE_VERSION) \
	$(XS_DEFINE_VERSION)

# --- MakeMaker post_constants section:


# --- MakeMaker pasthru section:

PASTHRU = LIB="$(LIB)"\
	LIBPERL_A="$(LIBPERL_A)"\
	LINKTYPE="$(LINKTYPE)"\
	PREFIX="$(PREFIX)"\
	OPTIMIZE="$(OPTIMIZE)"\
	PASTHRU_DEFINE="$(PASTHRU_DEFINE)"\
	PASTHRU_INC="$(PASTHRU_INC)"


# --- MakeMaker special_targets section:
.SUFFIXES: .xs .c .C .cpp .i .s .cxx .cc $(OBJ_EXT)

.PHONY: all config static dynamic test linkext manifest



# --- MakeMaker c_o section:

.c.i:
	cc -E -c $(PASTHRU_INC) $(INC) \
	$(CCFLAGS) $(OPTIMIZE) \
	$(PERLTYPE) $(MPOLLUTE) $(DEFINE_VERSION) \
	$(XS_DEFINE_VERSION) $(CCCDLFLAGS) "-I$(PERL_INC)" $(PASTHRU_DEFINE) $(DEFINE) $*.c > $*.i

.c.s:
	$(CCCMD) -S $(CCCDLFLAGS) "-I$(PERL_INC)" $(PASTHRU_DEFINE) $(DEFINE) $*.c

.c$(OBJ_EXT):
	$(CCCMD) $(CCCDLFLAGS) "-I$(PERL_INC)" $(PASTHRU_DEFINE) $(DEFINE) $*.c

.C$(OBJ_EXT):
	$(CCCMD) $(CCCDLFLAGS) "-I$(PERL_INC)" $(PASTHRU_DEFINE) $(DEFINE) $*.C

.cpp$(OBJ_EXT):
	$(CCCMD) $(CCCDLFLAGS) "-I$(PERL_INC)" $(PASTHRU_DEFINE) $(DEFINE) $*.cpp

.cxx$(OBJ_EXT):
	$(CCCMD) $(CCCDLFLAGS) "-I$(PERL_INC)" $(PASTHRU_DEFINE) $(DEFINE) $*.cxx

.cc$(OBJ_EXT):
	$(CCCMD) $(CCCDLFLAGS) "-I$(PERL_INC)" $(PASTHRU_DEFINE) $(DEFINE) $*.cc


# --- MakeMaker xs_c section:

.xs.c:
	$(PERLRUN) $(XSUBPP) $(XSPROTOARG) $(XSUBPPARGS) $(XSUBPP_EXTRA_ARGS) $*.xs > $*.xsc && $(MV) $*.xsc $*.c


# --- MakeMaker xs_o section:

.xs$(OBJ_EXT):
	$(PERLRUN) $(XSUBPP) $(XSPROTOARG) $(XSUBPPARGS) $*.xs > $*.xsc && $(MV) $*.xsc $*.c
	$(CCCMD) $(CCCDLFLAGS) "-I$(PERL_INC)" $(PASTHRU_DEFINE) $(DEFINE) $*.c


# --- MakeMaker top_targets section:
all :: pure_all manifypods
	$(NOECHO) $(NOOP)


pure_all :: config pm_to_blib subdirs linkext
	$(NOECHO) $(NOOP)

subdirs :: $(MYEXTLIB)
	$(NOECHO) $(NOOP)

config :: $(FIRST_MAKEFILE) $(INST_LIBDIR)$(DIRFILESEP).exists
	$(NOECHO) $(NOOP)

config :: $(INST_ARCHAUTODIR)$(DIRFILESEP).exists
	$(NOECHO) $(NOOP)

config :: $(INST_AUTODIR)$(DIRFILESEP).exists
	$(NOECHO) $(NOOP)

$(INST_AUTODIR)/.exists :: /usr/lib/perl/5.8/CORE/perl.h
	$(NOECHO) $(MKPATH) $(INST_AUTODIR)
	$(NOECHO) $(EQUALIZE_TIMESTAMP) /usr/lib/perl/5.8/CORE/perl.h $(INST_AUTODIR)/.exists

	-$(NOECHO) $(CHMOD) $(PERM_RWX) $(INST_AUTODIR)

$(INST_LIBDIR)/.exists :: /usr/lib/perl/5.8/CORE/perl.h
	$(NOECHO) $(MKPATH) $(INST_LIBDIR)
	$(NOECHO) $(EQUALIZE_TIMESTAMP) /usr/lib/perl/5.8/CORE/perl.h $(INST_LIBDIR)/.exists

	-$(NOECHO) $(CHMOD) $(PERM_RWX) $(INST_LIBDIR)

$(INST_ARCHAUTODIR)/.exists :: /usr/lib/perl/5.8/CORE/perl.h
	$(NOECHO) $(MKPATH) $(INST_ARCHAUTODIR)
	$(NOECHO) $(EQUALIZE_TIMESTAMP) /usr/lib/perl/5.8/CORE/perl.h $(INST_ARCHAUTODIR)/.exists

	-$(NOECHO) $(CHMOD) $(PERM_RWX) $(INST_ARCHAUTODIR)

config :: $(INST_MAN3DIR)$(DIRFILESEP).exists
	$(NOECHO) $(NOOP)


$(INST_MAN3DIR)/.exists :: /usr/lib/perl/5.8/CORE/perl.h
	$(NOECHO) $(MKPATH) $(INST_MAN3DIR)
	$(NOECHO) $(EQUALIZE_TIMESTAMP) /usr/lib/perl/5.8/CORE/perl.h $(INST_MAN3DIR)/.exists

	-$(NOECHO) $(CHMOD) $(PERM_RWX) $(INST_MAN3DIR)

$(O_FILES): $(H_FILES)

help:
	perldoc ExtUtils::MakeMaker


# --- MakeMaker linkext section:

linkext :: $(LINKTYPE)
	$(NOECHO) $(NOOP)


# --- MakeMaker dlsyms section:


# --- MakeMaker dynamic section:

dynamic :: $(FIRST_MAKEFILE) $(INST_DYNAMIC) $(INST_BOOT)
	$(NOECHO) $(NOOP)


# --- MakeMaker dynamic_bs section:
BOOTSTRAP = $(BASEEXT).bs

# As Mkbootstrap might not write a file (if none is required)
# we use touch to prevent make continually trying to remake it.
# The DynaLoader only reads a non-empty file.
$(BOOTSTRAP): $(FIRST_MAKEFILE) $(BOOTDEP) $(INST_ARCHAUTODIR)$(DIRFILESEP).exists
	$(NOECHO) $(ECHO) "Running Mkbootstrap for $(NAME) ($(BSLOADLIBS))"
	$(NOECHO) $(PERLRUN) \
		"-MExtUtils::Mkbootstrap" \
		-e "Mkbootstrap('$(BASEEXT)','$(BSLOADLIBS)');"
	$(NOECHO) $(TOUCH) $(BOOTSTRAP)
	$(CHMOD) $(PERM_RW) $@

$(INST_BOOT): $(BOOTSTRAP) $(INST_ARCHAUTODIR)$(DIRFILESEP).exists
	$(NOECHO) $(RM_RF) $(INST_BOOT)
	-$(CP) $(BOOTSTRAP) $(INST_BOOT)
	$(CHMOD) $(PERM_RW) $@


# --- MakeMaker dynamic_lib section:

## ruli 0.24

=== tools/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# $Id: Makefile,v 1.16 2004/05/19 23:09:11 evertonm Exp $
+# $Id: Makefile,v 1.18 2004/05/31 05:57:41 evertonm Exp $
 #
 
 #
@@ -28,11 +28,12 @@
 CFLAGS  = -O2 -pipe -Wall -g -I$(INSTALL_INCLUDE_DIR) -I$(OOP_INCLUDE_DIR) \
           -I../src
 
-LDFLAGS = -L$(INSTALL_LIB_DIR) -L$(OOP_LIB_DIR) -lruli -loop $(SOLARIS_LDFLAGS) \
-          -L../src
+LDFLAGS = -L$(INSTALL_LIB_DIR) -L$(OOP_LIB_DIR) -lruli -loop \
+	$(SOLARIS_LDFLAGS) -L../src
 
 TARGETS = list resolve hostsolver srvsolver syncsolver addrsolver \
-	srvsolver2 addrsolver2 addrsolver3 rand cycle_res cycle_res2
+	srvsolver2 addrsolver2 addrsolver3 rand cycle_res cycle_res2 \
+	ipv6
 
 .PHONY: default
 default: $(TARGETS)
@@ -83,4 +84,7 @@
 cycle_res2: cycle_res2.o trivial_conf_handler.o
 	$(CC) $(LDFLAGS) -o $@ $^
 
+ipv6: ipv6.o
+	$(CC) $(LDFLAGS) -o $@ $^
 
+

## ruli 0.25

=== src/Makefile ===
--- 
+++ 
@@ -1,8 +1,10 @@
 #
-# $Id: Makefile,v 1.37 2004/05/31 05:57:40 evertonm Exp $
+# $Id: Makefile,v 1.39 2004/06/09 17:57:14 evertonm Exp $
 #
 
-#DEBUG = -DRULI_RES_DEBUG -DRULI_SRV_DEBUG -DRULI_TXT_COMPARE_DEBUG
+#DEBUG += -DRULI_SRV_DEBUG 
+#DEBUG += -DRULI_RES_DEBUG
+#DEBUG += -DRULI_TXT_COMPARE_DEBUG
 #DEBUG += -DRULI_SYNC_DEBUG
 #DEBUG += -DRULI_SEARCH_DEBUG
 #DEBUG += -DRULI_MSG_DUMP_DEBUG -DRULI_SOCK_DUMP_DEBUG

## ruli 0.26

=== sample/Makefile ===
--- 
+++ 
@@ -1,5 +1,6 @@
+
 #
-# $Id: Makefile,v 1.9 2004/05/31 22:18:03 evertonm Exp $
+# $Id: Makefile,v 1.12 2004/06/16 21:23:11 evertonm Exp $
 #
 
 #
@@ -9,9 +10,8 @@
 # OOP_LIB_DIR points the location of
 # Liboop libraries in your system
 #
-# Debian packaging likes this: OOP_BASE_DIR = /usr/lib
+# Debian packaging likes this: OOP_BASE_DIR = /usr
 #
-
 OOP_BASE_DIR    = /usr/local/oop
 OOP_INCLUDE_DIR = $(OOP_BASE_DIR)/include
 OOP_LIB_DIR     = $(OOP_BASE_DIR)/lib
@@ -28,13 +28,17 @@
 INSTALL_BIN_DIR     = $(INSTALL_BASE_DIR)/bin
 INSTALL_MAN_DIR     = $(INSTALL_BASE_DIR)/share/man
 
-#SOLARIS_LDFLAGS = -lresolv -lnsl -R$(OOP_LIB_DIR) -R$(INSTALL_LIB_DIR)
+PLATFORM=$(shell uname)
+
+ifeq ($(PLATFORM),SunOS)
+SOLARIS_LIBS = -lresolv -lnsl -lsocket
+endif
 
 CC      = gcc
 CFLAGS  = -O2 -pipe -Wall -g -I$(INSTALL_INCLUDE_DIR) -I$(OOP_INCLUDE_DIR) \
 	-I../src
-LDFLAGS = -L$(INSTALL_LIB_DIR) -L$(OOP_LIB_DIR) -lruli -loop \
-	$(SOLARIS_LDFLAGS) -L../src
+LDFLAGS = -L$(INSTALL_LIB_DIR) -L$(OOP_LIB_DIR) $(SOLARIS_LDFLAGS) -L../src
+LIBS = -lruli -loop $(SOLARIS_LIBS)
 
 TARGETS = srvsearch sync_srvsearch smtpsearch sync_smtpsearch ruli-getaddrinfo
 
@@ -63,17 +67,17 @@
 	cd $(INSTALL_MAN_DIR)/man1 && ln -s srvsearch.1 ruli-getaddrinfo.1
 
 srvsearch: srvsearch.o stdout_srv_list.o
-	$(CC) $(LDFLAGS) -o $@ $^
+	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)
 
 sync_srvsearch: sync_srvsearch.o stdout_srv_list.o
-	$(CC) $(LDFLAGS) -o $@ $^
+	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)
 
 smtpsearch: smtpsearch.o stdout_srv_list.o
-	$(CC) $(LDFLAGS) -o $@ $^
+	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)
 
 sync_smtpsearch: sync_smtpsearch.o stdout_srv_list.o
-	$(CC) $(LDFLAGS) -o $@ $^
+	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)
 
 ruli-getaddrinfo: ruli-getaddrinfo.o stdout_srv_list.o
-	$(CC) $(LDFLAGS) -o $@ $^
+	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)

=== src/Makefile ===
#
# $Id: Makefile,v 1.47 2004/06/17 07:28:45 evertonm Exp $
#

#DEBUG += -DRULI_SRV_DEBUG 
#DEBUG += -DRULI_RES_DEBUG
#DEBUG += -DRULI_TXT_COMPARE_DEBUG
#DEBUG += -DRULI_SYNC_DEBUG
#DEBUG += -DRULI_SEARCH_DEBUG
#DEBUG += -DRULI_MSG_DUMP_DEBUG -DRULI_SOCK_DUMP_DEBUG
#DEBUG += -DRULI_SMTP_DEBUG

#
# OOP_INCLUDE_DIR points the location of
# Liboop headers in your system
#
# Debian packaging likes this: OOP_BASE_DIR = /usr
#
OOP_BASE_DIR    = /usr/local/oop
OOP_INCLUDE_DIR = $(OOP_BASE_DIR)/include

#
# INSTALL_BASE_DIR indicates where RULI
# is to be installed in your system
#
# Example: INSTALL_BASE_DIR=/usr/local/ruli
#
# Debian packaging likes this: INSTALL_BASE_DIR = $(DESTDIR)/usr
#
INSTALL_BASE_DIR     = ../install/ruli
INSTALL_INCLUDE_DIR  = $(INSTALL_BASE_DIR)/include
INSTALL_LIB_DIR      = $(INSTALL_BASE_DIR)/lib
INSTALL_MAN_DIR      = $(INSTALL_BASE_DIR)/share/man

# SunOS, Linux
PLATFORM=$(shell uname)

ifeq ($(PLATFORM),SunOS)
DEFINE_SOLARIS = -D_RULI_SOLARIS_
endif

WARN = -pedantic -ansi -Wshadow -Wpointer-arith -Wcast-qual \
	-Wcast-align -Wwrite-strings -Wstrict-prototypes \
	-Wmissing-prototypes -Wredundant-decls
CC = gcc

ifeq ($(CC),gcc)
WARN += -Wnested-externs
endif

FLAGS = $(DEBUG) -O2 -pipe -Wall -g -shared -fPIC \
        $(DEFINE_SOLARIS) -I. -I$(OOP_INCLUDE_DIR)
SOFT_CFLAGS = $(WARN) $(FLAGS)
CFLAGS = $(WARN) -Werror $(FLAGS)
LIBOBJ = ruli_isaac.o ruli_mem.o ruli_rand.o ruli_util.o ruli_list.o \
	ruli_addr.o ruli_sock.o ruli_txt.o ruli_msg.o ruli_fsm.o \
	ruli_res.o ruli_parse.o ruli_srv.o ruli_conf.o ruli_search.o \
	ruli_smtp.o ruli_sync.o ruli_getaddrinfo.o
SONAME = libruli.so.2

COMPILE = $(CC) $(CPPFLAGS) $(CFLAGS) -c

# no -Werror
SOFT_COMPILE = $(CC) $(CPPFLAGS) $(SOFT_CFLAGS) -c

.PHONY: default
default: ruli

.PHONY: clean
clean:
	rm -f *~ .*~ *.o *.so *.a *.so.*

.PHONY: build
build: clean default

.PHONY: strip
strip: ruli
	strip $(SONAME) libruli.a

.PHONY: install
install: ruli
	install -d $(INSTALL_LIB_DIR) \
		$(INSTALL_INCLUDE_DIR) \
		$(INSTALL_MAN_DIR)/man3
	install -m 644 $(SONAME) libruli.a $(INSTALL_LIB_DIR)
	install -m 644 *.h $(INSTALL_INCLUDE_DIR)
	install -m 644 ../doc/man/*.3 $(INSTALL_MAN_DIR)/man3
	cd $(INSTALL_LIB_DIR) && ln -s $(SONAME) libruli.so
	@echo
	@echo "REMINDER:"
	@echo "Add $(INSTALL_LIB_DIR) to your dynamic loader path:"
	@echo "# echo $(INSTALL_LIB_DIR) >> /etc/ld.so.conf"
	@echo "# ldconfig"
	@echo

.PHONY: ruli
ruli: $(SONAME) libruli.a

ruli_util.o: ruli_util.c ruli_util.h
	$(SOFT_COMPILE) $<

ruli_sock.o: ruli_sock.c ruli_sock.h
	$(SOFT_COMPILE) $<

%.o: %.c %.h
	$(COMPILE) $<

libruli.so: $(LIBOBJ)
ifdef DEFINE_SOLARIS
	$(CC) $(CFLAGS) -Wl,-h,$(SONAME) -o $@ $(LIBOBJ) -loop -ldl -lsocket -lnsl
else
	$(CC) $(CFLAGS) -Wl,-soname,$(SONAME) -Wl,--version-script,libruli.ver -o $@ $(LIBOBJ) -loop -ldl
endif

$(SONAME): libruli.so
	cp libruli.so $(SONAME)

libruli.a: $(LIBOBJ)
ifdef DEFINE_SOLARIS
	ar -r -v $@ $(LIBOBJ)
else
	ar rcv $@ $(LIBOBJ)
	ar sv $@
endif

=== tools/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# $Id: Makefile,v 1.18 2004/05/31 05:57:41 evertonm Exp $
+# $Id: Makefile,v 1.19 2004/06/16 21:23:11 evertonm Exp $
 #
 
 #
@@ -21,8 +21,6 @@
 INSTALL_INCLUDE_DIR = $(INSTALL_BASE_DIR)/include
 INSTALL_LIB_DIR     = $(INSTALL_BASE_DIR)/lib
 INSTALL_BIN_DIR     = $(INSTALL_BASE_DIR)/bin
-
-#SOLARIS_LDFLAGS = -lresolv -lnsl -R$(OOP_LIB_DIR) -R$(INSTALL_LIB_DIR)
 
 CC      = gcc
 CFLAGS  = -O2 -pipe -Wall -g -I$(INSTALL_INCLUDE_DIR) -I$(OOP_INCLUDE_DIR) \
@@ -87,4 +85,6 @@
 ipv6: ipv6.o
 	$(CC) $(LDFLAGS) -o $@ $^
 
+long: long.o
+	$(CC) -o $@ $^

## ruli 0.27

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# $Id: Makefile,v 1.7 2004/05/21 19:34:16 evertonm Exp $
+# $Id: Makefile,v 1.8 2004/05/21 20:25:30 evertonm Exp $
 #
 # This is a Debian-friendly top-level Makefile.
 #
@@ -29,5 +29,5 @@
 
 .PHONY: release-clean
 release-clean:
-	rm -r debian doc/rfc ruli-mta test tube `find . -name CVS`
+	rm -rf debian doc/rfc ruli-mta test tube `find . -name CVS`

=== sample/Makefile ===

#
# $Id: Makefile,v 1.14 2004/06/21 00:28:23 evertonm Exp $
#

#
# INSTALL_BASE_DIR indicates where RULI
# is to be installed in your system
#
# Debian packaging likes this: INSTALL_BASE_DIR = $(DESTDIR)/usr
#
INSTALL_BASE_DIR    = $(DESTDIR)/usr
INSTALL_INCLUDE_DIR = $(INSTALL_BASE_DIR)/include
INSTALL_LIB_DIR     = $(INSTALL_BASE_DIR)/lib
INSTALL_BIN_DIR     = $(INSTALL_BASE_DIR)/bin
INSTALL_MAN_DIR     = $(INSTALL_BASE_DIR)/share/man

PLATFORM=$(shell uname)

ifeq ($(PLATFORM),SunOS)
SOLARIS_LIBS = -lresolv -lnsl -lsocket
endif

CC      = gcc
CFLAGS  = -O2 -pipe -Wall -g -I../src
LDFLAGS = -L../src $(SOLARIS_LDFLAGS)
LIBS = -lruli -loop $(SOLARIS_LIBS)

TARGETS = srvsearch sync_srvsearch smtpsearch sync_smtpsearch ruli-getaddrinfo
SHARED_OBJS = stdout_srv_list.o parse_options.o

.PHONY: default
default: $(TARGETS)

.PHONY: clean
clean:
	rm -f *~ .*~ *.o $(TARGETS)

.PHONY: build
build: clean default

.PHONY: strip
strip: $(TARGETS)
	strip $(TARGETS)

.PHONY: install
install: $(TARGETS)
	install -d $(INSTALL_BIN_DIR) $(INSTALL_MAN_DIR)/man1
	install -m 755 $(TARGETS) $(INSTALL_BIN_DIR)
	install -m 644 ../doc/man/*.1 $(INSTALL_MAN_DIR)/man1
	cd $(INSTALL_MAN_DIR)/man1 && ln -s srvsearch.1 smtpsearch.1
	cd $(INSTALL_MAN_DIR)/man1 && ln -s srvsearch.1 sync_srvsearch.1
	cd $(INSTALL_MAN_DIR)/man1 && ln -s srvsearch.1 sync_smtpsearch.1
	cd $(INSTALL_MAN_DIR)/man1 && ln -s srvsearch.1 ruli-getaddrinfo.1

srvsearch: srvsearch.o $(SHARED_OBJS)
	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)

sync_srvsearch: sync_srvsearch.o $(SHARED_OBJS)
	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)

smtpsearch: smtpsearch.o $(SHARED_OBJS)
	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)

sync_smtpsearch: sync_smtpsearch.o $(SHARED_OBJS)
	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)

ruli-getaddrinfo: ruli-getaddrinfo.o $(SHARED_OBJS)
	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)

=== src/Makefile ===
--- 
+++ 
@@ -1,23 +1,15 @@
 #
-# $Id: Makefile,v 1.47 2004/06/17 07:28:45 evertonm Exp $
+# $Id: Makefile,v 1.48 2004/06/23 19:47:29 evertonm Exp $
 #
 
 #DEBUG += -DRULI_SRV_DEBUG 
+#DEBUG += -DRULI_HOST_DEBUG
 #DEBUG += -DRULI_RES_DEBUG
 #DEBUG += -DRULI_TXT_COMPARE_DEBUG
 #DEBUG += -DRULI_SYNC_DEBUG
 #DEBUG += -DRULI_SEARCH_DEBUG
 #DEBUG += -DRULI_MSG_DUMP_DEBUG -DRULI_SOCK_DUMP_DEBUG
 #DEBUG += -DRULI_SMTP_DEBUG
-
-#
-# OOP_INCLUDE_DIR points the location of
-# Liboop headers in your system
-#
-# Debian packaging likes this: OOP_BASE_DIR = /usr
-#
-OOP_BASE_DIR    = /usr/local/oop
-OOP_INCLUDE_DIR = $(OOP_BASE_DIR)/include
 
 #
 # INSTALL_BASE_DIR indicates where RULI
@@ -27,7 +19,7 @@
 #
 # Debian packaging likes this: INSTALL_BASE_DIR = $(DESTDIR)/usr
 #
-INSTALL_BASE_DIR     = ../install/ruli
+INSTALL_BASE_DIR     = $(DESTDIR)/usr
 INSTALL_INCLUDE_DIR  = $(INSTALL_BASE_DIR)/include
 INSTALL_LIB_DIR      = $(INSTALL_BASE_DIR)/lib
 INSTALL_MAN_DIR      = $(INSTALL_BASE_DIR)/share/man
@@ -49,13 +41,13 @@
 endif
 
 FLAGS = $(DEBUG) -O2 -pipe -Wall -g -shared -fPIC \
-        $(DEFINE_SOLARIS) -I. -I$(OOP_INCLUDE_DIR)
+        $(DEFINE_SOLARIS) -I.
 SOFT_CFLAGS = $(WARN) $(FLAGS)
 CFLAGS = $(WARN) -Werror $(FLAGS)
 LIBOBJ = ruli_isaac.o ruli_mem.o ruli_rand.o ruli_util.o ruli_list.o \
 	ruli_addr.o ruli_sock.o ruli_txt.o ruli_msg.o ruli_fsm.o \
-	ruli_res.o ruli_parse.o ruli_srv.o ruli_conf.o ruli_search.o \
-	ruli_smtp.o ruli_sync.o ruli_getaddrinfo.o
+	ruli_res.o ruli_parse.o ruli_host.o ruli_srv.o ruli_conf.o \
+	ruli_search.o ruli_smtp.o ruli_sync.o ruli_getaddrinfo.o
 SONAME = libruli.so.2
 
 COMPILE = $(CC) $(CPPFLAGS) $(CFLAGS) -c

## ruli 0.28

=== sample/Makefile ===
--- 
+++ 
@@ -2,6 +2,19 @@
 #
 # $Id: Makefile,v 1.14 2004/06/21 00:28:23 evertonm Exp $
 #
+
+#
+# OOP_INCLUDE_DIR points the location of
+# Liboop headers in your system
+#
+# OOP_LIB_DIR points the location of
+# Liboop libraries in your system
+#
+# Debian packaging likes this: OOP_BASE_DIR = /usr
+#
+OOP_BASE_DIR    = /usr/local/oop
+OOP_INCLUDE_DIR = $(OOP_BASE_DIR)/include
+OOP_LIB_DIR     = $(OOP_BASE_DIR)/lib
 
 #
 # INSTALL_BASE_DIR indicates where RULI
@@ -9,7 +22,7 @@
 #
 # Debian packaging likes this: INSTALL_BASE_DIR = $(DESTDIR)/usr
 #
-INSTALL_BASE_DIR    = $(DESTDIR)/usr
+INSTALL_BASE_DIR    = ../install/ruli
 INSTALL_INCLUDE_DIR = $(INSTALL_BASE_DIR)/include
 INSTALL_LIB_DIR     = $(INSTALL_BASE_DIR)/lib
 INSTALL_BIN_DIR     = $(INSTALL_BASE_DIR)/bin
@@ -22,8 +35,8 @@
 endif
 
 CC      = gcc
-CFLAGS  = -O2 -pipe -Wall -g -I../src
-LDFLAGS = -L../src $(SOLARIS_LDFLAGS)
+CFLAGS  = -O2 -pipe -Wall -g -I../src -I$(OOP_INCLUDE_DIR)
+LDFLAGS = -L../src -L$(OOP_LIB_DIR) $(SOLARIS_LDFLAGS)
 LIBS = -lruli -loop $(SOLARIS_LIBS)
 
 TARGETS = srvsearch sync_srvsearch smtpsearch sync_smtpsearch ruli-getaddrinfo

=== src/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# $Id: Makefile,v 1.48 2004/06/23 19:47:29 evertonm Exp $
+# $Id: Makefile,v 1.49 2004/06/25 23:19:11 evertonm Exp $
 #
 
 #DEBUG += -DRULI_SRV_DEBUG 
@@ -12,6 +12,15 @@
 #DEBUG += -DRULI_SMTP_DEBUG
 
 #
+# OOP_INCLUDE_DIR points the location of
+# Liboop headers in your system
+#
+# Debian packaging likes this: OOP_BASE_DIR = /usr
+#
+OOP_BASE_DIR    = /usr/local/oop
+OOP_INCLUDE_DIR = $(OOP_BASE_DIR)/include
+
+#
 # INSTALL_BASE_DIR indicates where RULI
 # is to be installed in your system
 #
@@ -19,7 +28,7 @@
 #
 # Debian packaging likes this: INSTALL_BASE_DIR = $(DESTDIR)/usr
 #
-INSTALL_BASE_DIR     = $(DESTDIR)/usr
+INSTALL_BASE_DIR     = ../install/ruli
 INSTALL_INCLUDE_DIR  = $(INSTALL_BASE_DIR)/include
 INSTALL_LIB_DIR      = $(INSTALL_BASE_DIR)/lib
 INSTALL_MAN_DIR      = $(INSTALL_BASE_DIR)/share/man
@@ -41,14 +50,14 @@
 endif
 
 FLAGS = $(DEBUG) -O2 -pipe -Wall -g -shared -fPIC \
-        $(DEFINE_SOLARIS) -I.
+        $(DEFINE_SOLARIS) -I. -I$(OOP_INCLUDE_DIR)
 SOFT_CFLAGS = $(WARN) $(FLAGS)
 CFLAGS = $(WARN) -Werror $(FLAGS)
 LIBOBJ = ruli_isaac.o ruli_mem.o ruli_rand.o ruli_util.o ruli_list.o \
 	ruli_addr.o ruli_sock.o ruli_txt.o ruli_msg.o ruli_fsm.o \
 	ruli_res.o ruli_parse.o ruli_host.o ruli_srv.o ruli_conf.o \
 	ruli_search.o ruli_smtp.o ruli_sync.o ruli_getaddrinfo.o
-SONAME = libruli.so.2
+SONAME = libruli.so.3
 
 COMPILE = $(CC) $(CPPFLAGS) $(CFLAGS) -c

=== tools/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# $Id: Makefile,v 1.19 2004/06/16 21:23:11 evertonm Exp $
+# $Id: Makefile,v 1.21 2004/06/23 19:47:29 evertonm Exp $
 #
 
 #
@@ -23,15 +23,13 @@
 INSTALL_BIN_DIR     = $(INSTALL_BASE_DIR)/bin
 
 CC      = gcc
-CFLAGS  = -O2 -pipe -Wall -g -I$(INSTALL_INCLUDE_DIR) -I$(OOP_INCLUDE_DIR) \
-          -I../src
+CFLAGS  = -O2 -pipe -Wall -g -I../src -I$(OOP_INCLUDE_DIR)
 
-LDFLAGS = -L$(INSTALL_LIB_DIR) -L$(OOP_LIB_DIR) -lruli -loop \
-	$(SOLARIS_LDFLAGS) -L../src
+LDFLAGS = -L../src -L$(OOP_LIB_DIR) -lruli -loop
 
 TARGETS = list resolve hostsolver srvsolver syncsolver addrsolver \
-	srvsolver2 addrsolver2 addrsolver3 rand cycle_res cycle_res2 \
-	ipv6
+	srvsolver2 addrsolver2 addrsolver3 ruli-host rand cycle_res \
+        cycle_res2 ipv6
 
 .PHONY: default
 default: $(TARGETS)
@@ -76,6 +74,9 @@
 addrsolver3: addrsolver3.o trivial_conf_handler.o
 	$(CC) $(LDFLAGS) -o $@ $^
 
+ruli-host: ruli-host.o trivial_conf_handler.o
+	$(CC) $(LDFLAGS) -o $@ $^
+
 cycle_res: cycle_res.o trivial_conf_handler.o
 	$(CC) $(LDFLAGS) -o $@ $^
 
@@ -85,6 +86,3 @@
 ipv6: ipv6.o
 	$(CC) $(LDFLAGS) -o $@ $^
 
-long: long.o
-	$(CC) -o $@ $^
-

## ruli 0.29

=== guile/Makefile ===
#
# $Id: Makefile,v 1.4 2004/08/15 06:21:45 evertonm Exp $
#

WARN = -pedantic -ansi -Wshadow -Wpointer-arith -Wcast-qual \
        -Wcast-align -Wwrite-strings -Wstrict-prototypes \
        -Wmissing-prototypes -Wredundant-decls \
	-Wall \
#	-Werror
CFLAGS = $(WARN) -O2 -pipe -g -shared -D_REENTRANT -D__USE_GNU \
	-fPIC $(shell guile-config compile)
LDFLAGS = -lruli $(shell guile-config link)
CC = gcc

.PHONY: default
default: ruli-guile

.PHONY: clean
clean:
	rm -f *.o *.so *~ ruli-guile

.PHONY: build
build: clean default

ruli-guile: ruli-guile.o libguile-ruli.so

libguile-ruli.so: guile_ruli.o
	gcc -shared -o $@ $< -lruli

=== sample/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 
 #
-# $Id: Makefile,v 1.14 2004/06/21 00:28:23 evertonm Exp $
+# $Id: Makefile,v 1.15 2004/07/07 17:39:13 evertonm Exp $
 #
 
 #
@@ -38,6 +38,7 @@
 CFLAGS  = -O2 -pipe -Wall -g -I../src -I$(OOP_INCLUDE_DIR)
 LDFLAGS = -L../src -L$(OOP_LIB_DIR) $(SOLARIS_LDFLAGS)
 LIBS = -lruli -loop $(SOLARIS_LIBS)
+LINK = $(CC) $(ARCH) $(LDFLAGS) -o $@ $^ $(LIBS)
 
 TARGETS = srvsearch sync_srvsearch smtpsearch sync_smtpsearch ruli-getaddrinfo
 SHARED_OBJS = stdout_srv_list.o parse_options.o
@@ -66,18 +67,21 @@
 	cd $(INSTALL_MAN_DIR)/man1 && ln -s srvsearch.1 sync_smtpsearch.1
 	cd $(INSTALL_MAN_DIR)/man1 && ln -s srvsearch.1 ruli-getaddrinfo.1
 
+%.o: %.c
+	$(CC) $(ARCH) $(CPPFLAGS) $(CFLAGS) -c $<
+
 srvsearch: srvsearch.o $(SHARED_OBJS)
-	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)
+	$(LINK)
 
 sync_srvsearch: sync_srvsearch.o $(SHARED_OBJS)
-	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)
+	$(LINK)
 
 smtpsearch: smtpsearch.o $(SHARED_OBJS)
-	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)
+	$(LINK)
 
 sync_smtpsearch: sync_smtpsearch.o $(SHARED_OBJS)
-	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)
+	$(LINK)
 
 ruli-getaddrinfo: ruli-getaddrinfo.o $(SHARED_OBJS)
-	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)
+	$(LINK)

=== src/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# $Id: Makefile,v 1.49 2004/06/25 23:19:11 evertonm Exp $
+# $Id: Makefile,v 1.50 2004/07/07 17:39:13 evertonm Exp $
 #
 
 #DEBUG += -DRULI_SRV_DEBUG 
@@ -49,7 +49,8 @@
 WARN += -Wnested-externs
 endif
 
-FLAGS = $(DEBUG) -O2 -pipe -Wall -g -shared -fPIC \
+SHARED = -fPIC
+FLAGS = $(DEBUG) -O2 -pipe -Wall -g -shared -D_REENTRANT \
         $(DEFINE_SOLARIS) -I. -I$(OOP_INCLUDE_DIR)
 SOFT_CFLAGS = $(WARN) $(FLAGS)
 CFLAGS = $(WARN) -Werror $(FLAGS)
@@ -57,19 +58,22 @@
 	ruli_addr.o ruli_sock.o ruli_txt.o ruli_msg.o ruli_fsm.o \
 	ruli_res.o ruli_parse.o ruli_host.o ruli_srv.o ruli_conf.o \
 	ruli_search.o ruli_smtp.o ruli_sync.o ruli_getaddrinfo.o
+SHAREDOBJ = $(LIBOBJ:%.o=%.os)
 SONAME = libruli.so.3
 
-COMPILE = $(CC) $(CPPFLAGS) $(CFLAGS) -c
+COMPILE = $(CC) $(ARCH) $(CPPFLAGS) $(CFLAGS) -c
+SHARED_COMPILE = $(CC) $(ARCH) $(CPPFLAGS) $(SHARED) $(CFLAGS) -o $@ -c
 
 # no -Werror
-SOFT_COMPILE = $(CC) $(CPPFLAGS) $(SOFT_CFLAGS) -c
+SOFT_COMPILE = $(CC) $(ARCH) $(CPPFLAGS) $(SOFT_CFLAGS) -c
+SHARED_SOFT_COMPILE = $(CC) $(ARCH) $(CPPFLAGS) $(SHARED) $(SOFT_CFLAGS) -o $@ -c
 
 .PHONY: default
 default: ruli
 
 .PHONY: clean
 clean:
-	rm -f *~ .*~ *.o *.so *.a *.so.*
+	rm -f *~ .*~ *.o *.os *.so *.a *.so.*
 
 .PHONY: build
 build: clean default
@@ -103,14 +107,25 @@
 ruli_sock.o: ruli_sock.c ruli_sock.h
 	$(SOFT_COMPILE) $<
 
+ruli_util.os: ruli_util.c ruli_util.h
+	$(SHARED_SOFT_COMPILE) $<
+
+ruli_sock.os: ruli_sock.c ruli_sock.h
+	$(SHARED_SOFT_COMPILE) $<
+
 %.o: %.c %.h
 	$(COMPILE) $<
 
-libruli.so: $(LIBOBJ)
+%.os: %.c %.h
+	$(SHARED_COMPILE) $<
+
+libruli.so: $(SHAREDOBJ)
 ifdef DEFINE_SOLARIS
-	$(CC) $(CFLAGS) -Wl,-h,$(SONAME) -o $@ $(LIBOBJ) -loop -ldl -lsocket -lnsl
+	$(CC) $(ARCH) $(CFLAGS) -Wl,-h,$(SONAME) -o $@ \
+		$(SHAREDOBJ) -loop -ldl -lsocket -lnsl
 else
-	$(CC) $(CFLAGS) -Wl,-soname,$(SONAME) -Wl,--version-script,libruli.ver -o $@ $(LIBOBJ) -loop -ldl
+	$(CC) $(ARCH) $(CFLAGS) -Wl,-soname,$(SONAME) \
+		-Wl,--version-script,libruli.ver -o $@ $(SHAREDOBJ) -loop -ldl
 endif
 
 $(SONAME): libruli.so
